libimobiledevice: libimobiledevice/afc.h File Reference

libimobiledevice 1.3.0

Macros | Typedefs | Enumerations | Functions
afc.h File Reference

Access the filesystem on the device. More...

## Macros
#define | AFC_SERVICE_NAME "com.apple.afc"

## Typedefs
typedef struct afc_client_private | afc_client_private
typedef afc_client_private * | afc_client_t
| The client handle.

## Enumerations
enum | afc_error_t { AFC_E_SUCCESS = 0, AFC_E_UNKNOWN_ERROR = 1, AFC_E_OP_HEADER_INVALID = 2, AFC_E_NO_RESOURCES = 3, AFC_E_READ_ERROR = 4, AFC_E_WRITE_ERROR = 5, AFC_E_UNKNOWN_PACKET_TYPE = 6, AFC_E_INVALID_ARG = 7, AFC_E_OBJECT_NOT_FOUND = 8, AFC_E_OBJECT_IS_DIR = 9, AFC_E_PERM_DENIED = 10, AFC_E_SERVICE_NOT_CONNECTED = 11, AFC_E_OP_TIMEOUT = 12, AFC_E_TOO_MUCH_DATA = 13, AFC_E_END_OF_DATA = 14, AFC_E_OP_NOT_SUPPORTED = 15, AFC_E_OBJECT_EXISTS = 16, AFC_E_OBJECT_BUSY = 17, AFC_E_NO_SPACE_LEFT = 18, AFC_E_OP_WOULD_BLOCK = 19, AFC_E_IO_ERROR = 20, AFC_E_OP_INTERRUPTED = 21, AFC_E_OP_IN_PROGRESS = 22, AFC_E_INTERNAL_ERROR = 23, AFC_E_MUX_ERROR = 30, AFC_E_NO_MEM = 31, AFC_E_NOT_ENOUGH_DATA = 32, AFC_E_DIR_NOT_EMPTY = 33, AFC_E_FORCE_SIGNED_TYPE = -1 }
| Error Codes.
enum | afc_file_mode_t { AFC_FOPEN_RDONLY = 0x00000001, AFC_FOPEN_RW = 0x00000002, AFC_FOPEN_WRONLY = 0x00000003, AFC_FOPEN_WR = 0x00000004, AFC_FOPEN_APPEND = 0x00000005, AFC_FOPEN_RDAPPEND = 0x00000006 }
| Flags for afc_file_open. More...
enum | afc_link_type_t { AFC_HARDLINK = 1, AFC_SYMLINK = 2 }
| Type of link for afc_make_link() calls.
enum | afc_lock_op_t { AFC_LOCK_SH = 1 | 4, AFC_LOCK_EX = 2 | 4, AFC_LOCK_UN = 8 | 4 }
| Lock operation flags. More...

## Functions
afc_error_t | afc_client_new (idevice_t device, lockdownd_service_descriptor_t service, afc_client_t *client)
| Makes a connection to the AFC service on the device. More...
afc_error_t | afc_client_start_service (idevice_t device, afc_client_t *client, const char *label)
| Starts a new AFC service on the specified device and connects to it. More...
afc_error_t | afc_client_free (afc_client_t client)
| Frees up an AFC client. More...
afc_error_t | afc_get_device_info (afc_client_t client, char ***device_information)
| Get device information for a connected client. More...
afc_error_t | afc_read_directory (afc_client_t client, const char *path, char ***directory_information)
| Gets a directory listing of the directory requested. More...
afc_error_t | afc_get_file_info (afc_client_t client, const char *path, char ***file_information)
| Gets information about a specific file. More...
afc_error_t | afc_file_open (afc_client_t client, const char *filename, afc_file_mode_t file_mode, uint64_t *handle)
| Opens a file on the device. More...
afc_error_t | afc_file_close (afc_client_t client, uint64_t handle)
| Closes a file on the device. More...
afc_error_t | afc_file_lock (afc_client_t client, uint64_t handle, afc_lock_op_t operation)
| Locks or unlocks a file on the device. More...
afc_error_t | afc_file_read (afc_client_t client, uint64_t handle, char *data, uint32_t length, uint32_t *bytes_read)
| Attempts to the read the given number of bytes from the given file. More...
afc_error_t | afc_file_write (afc_client_t client, uint64_t handle, const char *data, uint32_t length, uint32_t *bytes_written)
| Writes a given number of bytes to a file. More...
afc_error_t | afc_file_seek (afc_client_t client, uint64_t handle, int64_t offset, int whence)
| Seeks to a given position of a pre-opened file on the device. More...
afc_error_t | afc_file_tell (afc_client_t client, uint64_t handle, uint64_t *position)
| Returns current position in a pre-opened file on the device. More...
afc_error_t | afc_file_truncate (afc_client_t client, uint64_t handle, uint64_t newsize)
| Sets the size of a file on the device. More...
afc_error_t | afc_remove_path (afc_client_t client, const char *path)
| Deletes a file or directory. More...
afc_error_t | afc_rename_path (afc_client_t client, const char *from, const char *to)
| Renames a file or directory on the device. More...
afc_error_t | afc_make_directory (afc_client_t client, const char *path)
| Creates a directory on the device. More...
afc_error_t | afc_truncate (afc_client_t client, const char *path, uint64_t newsize)
| Sets the size of a file on the device without prior opening it. More...
afc_error_t | afc_make_link (afc_client_t client, afc_link_type_t linktype, const char *target, const char *linkname)
| Creates a hard link or symbolic link on the device. More...
afc_error_t | afc_set_file_time (afc_client_t client, const char *path, uint64_t mtime)
| Sets the modification time of a file on the device. More...
afc_error_t | afc_remove_path_and_contents (afc_client_t client, const char *path)
| Deletes a file or directory including possible contents. More...
afc_error_t | afc_get_device_info_key (afc_client_t client, const char *key, char **value)
| Get a specific key of the device info list for a client connection. More...
afc_error_t | afc_dictionary_free (char **dictionary)
| Frees up a char dictionary as returned by some AFC functions. More...

## Detailed Description

Access the filesystem on the device.

## Enumeration Type Documentation

## ◆ afc_file_mode_t

enum afc_file_mode_t

Flags for afc_file_open.

Enumerator
AFC_FOPEN_RDONLY | r O_RDONLY
AFC_FOPEN_RW | r+ O_RDWR | O_CREAT
AFC_FOPEN_WRONLY | w O_WRONLY | O_CREAT | O_TRUNC
AFC_FOPEN_WR | w+ O_RDWR | O_CREAT | O_TRUNC
AFC_FOPEN_APPEND | a O_WRONLY | O_APPEND | O_CREAT
AFC_FOPEN_RDAPPEND | a+ O_RDWR | O_APPEND | O_CREAT

## ◆ afc_lock_op_t

enum afc_lock_op_t

Lock operation flags.

Enumerator
AFC_LOCK_SH | shared lock
AFC_LOCK_EX | exclusive lock
AFC_LOCK_UN | unlock

## Function Documentation

## ◆ afc_client_free()

afc_error_t afc_client_free | ( | afc_client_t | client | ) |

Frees up an AFC client.

If the connection was created by the client itself, the connection will be closed.

Parameters

  client | The client to free.

## ◆ afc_client_new()

afc_error_t afc_client_new | ( | idevice_t | device,
|  | lockdownd_service_descriptor_t | service,
|  | afc_client_t * | client
| ) |  |

Makes a connection to the AFC service on the device.

Parameters

  device | The device to connect to.
  service | The service descriptor returned by lockdownd_start_service.
  client | Pointer that will be set to a newly allocated afc_client_t upon successful return.

Returns
  AFC_E_SUCCESS on success, AFC_E_INVALID_ARG if device or service is invalid, AFC_E_MUX_ERROR if the connection cannot be established, or AFC_E_NO_MEM if there is a memory allocation problem.

## ◆ afc_client_start_service()

afc_error_t afc_client_start_service | ( | idevice_t | device,
|  | afc_client_t * | client,
|  | const char * | label
| ) |  |

Starts a new AFC service on the specified device and connects to it.

Parameters

  device | The device to connect to.
  client | Pointer that will point to a newly allocated afc_client_t upon successful return. Must be freed using afc_client_free() after use.
  label | The label to use for communication. Usually the program name. Pass NULL to disable sending the label in requests to lockdownd.

Returns
  AFC_E_SUCCESS on success, or an AFC_E_* error code otherwise.

## ◆ afc_dictionary_free()

afc_error_t afc_dictionary_free | ( | char ** | dictionary | ) |

Frees up a char dictionary as returned by some AFC functions.

Parameters

  dictionary | The char array terminated by an empty string.

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_file_close()

afc_error_t afc_file_close | ( | afc_client_t | client,
|  | uint64_t | handle
| ) |  |

Closes a file on the device.

Parameters

  client | The client to close the file with.
  handle | File handle of a previously opened file.

## ◆ afc_file_lock()

afc_error_t afc_file_lock | ( | afc_client_t | client,
|  | uint64_t | handle,
|  | afc_lock_op_t | operation
| ) |  |

Locks or unlocks a file on the device.

Makes use of flock on the device.

See also
  http://developer.apple.com/documentation/Darwin/Reference/ManPages/man2/flock.2.html

Parameters

  client | The client to lock the file with.
  handle | File handle of a previously opened file.
  operation | the lock or unlock operation to perform, this is one of AFC_LOCK_SH (shared lock), AFC_LOCK_EX (exclusive lock), or AFC_LOCK_UN (unlock).

## ◆ afc_file_open()

afc_error_t afc_file_open | ( | afc_client_t | client,
|  | const char * | filename,
|  | afc_file_mode_t | file_mode,
|  | uint64_t * | handle
| ) |  |

Opens a file on the device.

Parameters

  client | The client to use to open the file.
  filename | The file to open. (must be a fully-qualified path)
  file_mode | The mode to use to open the file.
  handle | Pointer to a uint64_t that will hold the handle of the file

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_file_read()

afc_error_t afc_file_read | ( | afc_client_t | client,
|  | uint64_t | handle,
|  | char * | data,
|  | uint32_t | length,
|  | uint32_t * | bytes_read
| ) |  |

Attempts to the read the given number of bytes from the given file.

Parameters

  client | The relevant AFC client
  handle | File handle of a previously opened file
  data | The pointer to the memory region to store the read data
  length | The number of bytes to read
  bytes_read | The number of bytes actually read.

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_file_seek()

afc_error_t afc_file_seek | ( | afc_client_t | client,
|  | uint64_t | handle,
|  | int64_t | offset,
|  | int | whence
| ) |  |

Seeks to a given position of a pre-opened file on the device.

Parameters

  client | The client to use to seek to the position.
  handle | File handle of a previously opened.
  offset | Seek offset.
  whence | Seeking direction, one of SEEK_SET, SEEK_CUR, or SEEK_END.

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_file_tell()

afc_error_t afc_file_tell | ( | afc_client_t | client,
|  | uint64_t | handle,
|  | uint64_t * | position
| ) |  |

Returns current position in a pre-opened file on the device.

Parameters

  client | The client to use.
  handle | File handle of a previously opened file.
  position | Position in bytes of indicator

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_file_truncate()

afc_error_t afc_file_truncate | ( | afc_client_t | client,
|  | uint64_t | handle,
|  | uint64_t | newsize
| ) |  |

Sets the size of a file on the device.

Parameters

  client | The client to use to set the file size.
  handle | File handle of a previously opened file.
  newsize | The size to set the file to.

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

Note
  This function is more akin to ftruncate than truncate, and truncate calls would have to open the file before calling this, sadly.

## ◆ afc_file_write()

afc_error_t afc_file_write | ( | afc_client_t | client,
|  | uint64_t | handle,
|  | const char * | data,
|  | uint32_t | length,
|  | uint32_t * | bytes_written
| ) |  |

Writes a given number of bytes to a file.

Parameters

  client | The client to use to write to the file.
  handle | File handle of previously opened file.
  data | The data to write to the file.
  length | How much data to write.
  bytes_written | The number of bytes actually written to the file.

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_get_device_info()

afc_error_t afc_get_device_info | ( | afc_client_t | client,
|  | char *** | device_information
| ) |  |

Get device information for a connected client.

The device information returned is the device model as well as the free space, the total capacity and blocksize on the accessed disk partition.

Parameters

  client | The client to get device info for.
  device_information | A char list of device information terminated by an empty string or NULL if there was an error. Free with afc_dictionary_free().

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_get_device_info_key()

afc_error_t afc_get_device_info_key | ( | afc_client_t | client,
|  | const char * | key,
|  | char ** | value
| ) |  |

Get a specific key of the device info list for a client connection.

Known key values are: Model, FSTotalBytes, FSFreeBytes and FSBlockSize. This is a helper function for afc_get_device_info().

Parameters

  client | The client to get device info for.
  key | The key to get the value of.
  value | The value for the key if successful or NULL otherwise.

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_get_file_info()

afc_error_t afc_get_file_info | ( | afc_client_t | client,
|  | const char * | path,
|  | char *** | file_information
| ) |  |

Gets information about a specific file.

Parameters

  client | The client to use to get the information of the file.
  path | The fully-qualified path to the file.
  file_information | Pointer to a buffer that will be filled with a NULL-terminated list of strings with the file information. Set to NULL before calling this function. Free with afc_dictionary_free().

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_make_directory()

afc_error_t afc_make_directory | ( | afc_client_t | client,
|  | const char * | path
| ) |  |

Creates a directory on the device.

Parameters

  client | The client to use to make a directory.
  path | The directory's path. (must be a fully-qualified path, I assume all other mkdir restrictions apply as well)

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_make_link()

afc_error_t afc_make_link | ( | afc_client_t | client,
|  | afc_link_type_t | linktype,
|  | const char * | target,
|  | const char * | linkname
| ) |  |

Creates a hard link or symbolic link on the device.

Parameters

  client | The client to use for making a link
  linktype | 1 = hard link, 2 = symlink
  target | The file to be linked.
  linkname | The name of link.

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_read_directory()

afc_error_t afc_read_directory | ( | afc_client_t | client,
|  | const char * | path,
|  | char *** | directory_information
| ) |  |

Gets a directory listing of the directory requested.

Parameters

  client | The client to get a directory listing from.
  path | The directory for listing. (must be a fully-qualified path)
  directory_information | A char list of files in the directory terminated by an empty string or NULL if there was an error. Free with afc_dictionary_free().

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_remove_path()

afc_error_t afc_remove_path | ( | afc_client_t | client,
|  | const char * | path
| ) |  |

Deletes a file or directory.

Parameters

  client | The client to use.
  path | The path to delete. (must be a fully-qualified path)

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_remove_path_and_contents()

afc_error_t afc_remove_path_and_contents | ( | afc_client_t | client,
|  | const char * | path
| ) |  |

Deletes a file or directory including possible contents.

Parameters

  client | The client to use.
  path | The path to delete. (must be a fully-qualified path)

Since
  libimobiledevice 1.1.7

Note
  Only available in iOS 6 and later.

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_rename_path()

afc_error_t afc_rename_path | ( | afc_client_t | client,
|  | const char * | from,
|  | const char * | to
| ) |  |

Renames a file or directory on the device.

Parameters

  client | The client to have rename.
  from | The name to rename from. (must be a fully-qualified path)
  to | The new name. (must also be a fully-qualified path)

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_set_file_time()

afc_error_t afc_set_file_time | ( | afc_client_t | client,
|  | const char * | path,
|  | uint64_t | mtime
| ) |  |

Sets the modification time of a file on the device.

Parameters

  client | The client to use to set the file size.
  path | Path of the file for which the modification time should be set.
  mtime | The modification time to set in nanoseconds since epoch.

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

## ◆ afc_truncate()

afc_error_t afc_truncate | ( | afc_client_t | client,
|  | const char * | path,
|  | uint64_t | newsize
| ) |  |

Sets the size of a file on the device without prior opening it.

Parameters

  client | The client to use to set the file size.
  path | The path of the file to be truncated.
  newsize | The size to set the file to.

Returns
  AFC_E_SUCCESS on success or an AFC_E_* error value.

companion_proxy_start_forwarding_service_port
companion_proxy_error_t companion_proxy_start_forwarding_service_port(companion_proxy_client_t client, uint16_t remote_port, const char *service_name, uint16_t *forward_port, plist_t options)
Start forwarding a service port on the companion device to a port on the idevice.
mobileactivation_client_free
mobileactivation_error_t mobileactivation_client_free(mobileactivation_client_t client)
Disconnects a mobileactivation client from the device and frees up the mobileactivation client data.
afc_rename_path
afc_error_t afc_rename_path(afc_client_t client, const char *from, const char *to)
Renames a file or directory on the device.
idevice_connection_receive
idevice_error_t idevice_connection_receive(idevice_connection_t connection, char *data, uint32_t len, uint32_t *recv_bytes)
Receive data from a device via the given connection.
house_arrest_error_t
house_arrest_error_t
Error Codes.
Definition: house_arrest.h:38
mobilebackup_send_error
mobilebackup_error_t mobilebackup_send_error(mobilebackup_client_t client, const char *reason)
Sends a backup error message to the device.
companion_proxy_get_value_from_registry
companion_proxy_error_t companion_proxy_get_value_from_registry(companion_proxy_client_t client, const char *companion_udid, const char *key, plist_t *value)
Returns a value for the given key.
np_observe_notification
np_error_t np_observe_notification(np_client_t client, const char *notification)
Tells the device to send a notification on the specified event.
mobile_image_mounter_upload_cb_t
ssize_t(* mobile_image_mounter_upload_cb_t)(void *buffer, size_t length, void *user_data)
callback for image upload
Definition: mobile_image_mounter.h:51
debugserver_client_new
debugserver_error_t debugserver_client_new(idevice_t device, lockdownd_service_descriptor_t service, debugserver_client_t *client)
Connects to the debugserver service on the specified device.
idevice_event_subscribe
idevice_error_t idevice_event_subscribe(idevice_event_cb_t callback, void *user_data)
Register a callback function that will be called when device add/remove events occur.
mobilebackup_client_start_service
mobilebackup_error_t mobilebackup_client_start_service(idevice_t device, mobilebackup_client_t *client, const char *label)
Starts a new mobilebackup service on the specified device and connects to it.
mobilebackup_send
mobilebackup_error_t mobilebackup_send(mobilebackup_client_t client, plist_t plist)
Sends mobilebackup data to the device.
mobileactivation_get_activation_state
mobileactivation_error_t mobileactivation_get_activation_state(mobileactivation_client_t client, plist_t *state)
Retrieves the device's activation state.
preboard_create_stashbag
preboard_error_t preboard_create_stashbag(preboard_client_t client, plist_t manifest, preboard_status_cb_t status_cb, void *user_data)
Tells the preboard service to create a stashbag.
instproxy_install
instproxy_error_t instproxy_install(instproxy_client_t client, const char *pkg_path, plist_t client_options, instproxy_status_cb_t status_cb, void *user_data)
Install an application on the device.
screenshotr_error_t
screenshotr_error_t
Error Codes.
Definition: screenshotr.h:38
instproxy_restore
instproxy_error_t instproxy_restore(instproxy_client_t client, const char *appid, plist_t client_options, instproxy_status_cb_t status_cb, void *user_data)
Restore a previously archived application on the device.
debugserver_client_t
debugserver_client_private * debugserver_client_t
The client handle.
Definition: debugserver.h:47
sbservices_set_icon_state
sbservices_error_t sbservices_set_icon_state(sbservices_client_t client, plist_t newstate)
Sets the icon state of the connected device.
lockdownd_client_t
lockdownd_client_private * lockdownd_client_t
The client handle.
Definition: lockdown.h:84
debugserver_client_set_environment_hex_encoded
debugserver_error_t debugserver_client_set_environment_hex_encoded(debugserver_client_t client, const char *env, char **response)
Adds or sets an environment variable.
misagent_copy
misagent_error_t misagent_copy(misagent_client_t client, plist_t *profiles)
Retrieves all installed provisioning profiles (iOS 9.2.1 or below).
service_enable_ssl
service_error_t service_enable_ssl(service_client_t client)
Enable SSL for the given service client.
afc_client_new_from_house_arrest_client
afc_error_t afc_client_new_from_house_arrest_client(house_arrest_client_t client, afc_client_t *afc_client)
Creates an AFC client using the given house_arrest client's connection allowing file access to a spec...
idevice_new
idevice_error_t idevice_new(idevice_t *device, const char *udid)
Creates an idevice_t structure for the device specified by UDID, if the device is available (USBMUX d...
diagnostics_relay_client_start_service
diagnostics_relay_error_t diagnostics_relay_client_start_service(idevice_t device, diagnostics_relay_client_t *client, const char *label)
Starts a new diagnostics_relay service on the specified device and connects to it.
restored_client_new
restored_error_t restored_client_new(idevice_t device, restored_client_t *client, const char *label)
Creates a new restored client for the device.
restored_send
restored_error_t restored_send(restored_client_t client, plist_t plist)
Sends a plist to restored.
misagent_copy_all
misagent_error_t misagent_copy_all(misagent_client_t client, plist_t *profiles)
Retrieves all installed provisioning profiles (iOS 9.3 or higher).
mobilebackup2_error_t
mobilebackup2_error_t
Error Codes.
Definition: mobilebackup2.h:37
lockdownd_pair_record::system_buid
char * system_buid
A unique system id.
Definition: lockdown.h:91
mobilesync_acknowledge_changes_from_device
mobilesync_error_t mobilesync_acknowledge_changes_from_device(mobilesync_client_t client)
Acknowledges to the device that the changes have been merged on the computer.
debugserver_command_t
debugserver_command_private * debugserver_command_t
The command handle.
Definition: debugserver.h:50
house_arrest_client_t
house_arrest_client_private * house_arrest_client_t
The client handle.
Definition: house_arrest.h:48
mobilebackup_send_restore_complete
mobilebackup_error_t mobilebackup_send_restore_complete(mobilebackup_client_t client)
Tells the device that the restore process is complete and waits for the device to close the connectio...
debugserver_client_receive_response
debugserver_error_t debugserver_client_receive_response(debugserver_client_t client, char **response, size_t *response_size)
Receives and parses response of debugserver service.
np_error_t
np_error_t
Error Codes.
Definition: notification_proxy.h:37
lockdownd_data_classes_free
lockdownd_error_t lockdownd_data_classes_free(char **classes)
Frees memory of an allocated array of data classes as returned by lockdownd_get_sync_data_classes()
webinspector_send
webinspector_error_t webinspector_send(webinspector_client_t client, plist_t plist)
Sends a plist to the service.
companion_proxy_start_listening_for_devices
companion_proxy_error_t companion_proxy_start_listening_for_devices(companion_proxy_client_t client, companion_proxy_device_event_cb_t callback, void *userdata)
Starts listening for paired devices.
property_list_service_send_binary_plist
property_list_service_error_t property_list_service_send_binary_plist(property_list_service_client_t client, plist_t plist)
Sends a binary plist.
debugserver_error_t
debugserver_error_t
Error Codes.
Definition: debugserver.h:36
webinspector_receive_with_timeout
webinspector_error_t webinspector_receive_with_timeout(webinspector_client_t client, plist_t *plist, uint32_t timeout_ms)
Receives a plist using the given webinspector client.
afc_file_write
afc_error_t afc_file_write(afc_client_t client, uint64_t handle, const char *data, uint32_t length, uint32_t *bytes_written)
Writes a given number of bytes to a file.
screenshotr_take_screenshot
screenshotr_error_t screenshotr_take_screenshot(screenshotr_client_t client, char **imgdata, uint64_t *imgsize)
Get a screen shot from the connected device.
idevice_event_cb_t
void(* idevice_event_cb_t)(const idevice_event_t *event, void *user_data)
Callback to notifiy if a device was added or removed.
Definition: libimobiledevice.h:93
idevice_device_list_extended_free
idevice_error_t idevice_device_list_extended_free(idevice_info_t *devices)
Free an extended device list retrieved through idevice_get_device_list_extended().
mobilesync_remap_identifiers
mobilesync_error_t mobilesync_remap_identifiers(mobilesync_client_t client, plist_t *mapping)
Receives any remapped identifiers reported after the device merged submitted changes.
mobilebackup2_client_new
mobilebackup2_error_t mobilebackup2_client_new(idevice_t device, lockdownd_service_descriptor_t service, mobilebackup2_client_t *client)
Connects to the mobilebackup2 service on the specified device.
lockdownd_error_t
lockdownd_error_t
Error Codes.
Definition: lockdown.h:37
service_error_t
service_error_t
Error Codes.
Definition: service.h:34
mobilebackup_request_restore
mobilebackup_error_t mobilebackup_request_restore(mobilebackup_client_t client, plist_t backup_manifest, mobilebackup_flags_t flags, const char *proto_version)
Request that a backup should be restored to the connected device.
lockdownd_get_value
lockdownd_error_t lockdownd_get_value(lockdownd_client_t client, const char *domain, const char *key, plist_t *value)
Retrieves a preferences plist using an optional domain and/or key name.
afc_error_t
afc_error_t
Error Codes.
Definition: afc.h:37
mobilesync_anchors_new
mobilesync_anchors_t mobilesync_anchors_new(const char *device_anchor, const char *computer_anchor)
Allocates memory for a new anchors struct initialized with the passed anchors.
afc_link_type_t
afc_link_type_t
Type of link for afc_make_link() calls.
Definition: afc.h:80
idevice_connection_send
idevice_error_t idevice_connection_send(idevice_connection_t connection, const char *data, uint32_t len, uint32_t *sent_bytes)
Send data to a device via the given connection.
syslog_relay_start_capture
syslog_relay_error_t syslog_relay_start_capture(syslog_relay_client_t client, syslog_relay_receive_cb_t callback, void *user_data)
Starts capturing the syslog of the device using a callback.
sbservices_client_t
sbservices_client_private * sbservices_client_t
The client handle.
Definition: sbservices.h:57
instproxy_error_t
instproxy_error_t
Error Codes.
Definition: installation_proxy.h:39
service_disable_bypass_ssl
service_error_t service_disable_bypass_ssl(service_client_t client, uint8_t sslBypass)
Disable SSL for the given service client without sending SSL terminate messages.
idevice_get_device_list_extended
idevice_error_t idevice_get_device_list_extended(idevice_info_t **devices, int *count)
Get a list of currently available devices.
mobilebackup2_client_start_service
mobilebackup2_error_t mobilebackup2_client_start_service(idevice_t device, mobilebackup2_client_t *client, const char *label)
Starts a new mobilebackup2 service on the specified device and connects to it.
AFC_FOPEN_WRONLY
w O_WRONLY | O_CREAT | O_TRUNC
Definition: afc.h:73
lockdownd_validate_pair
lockdownd_error_t lockdownd_validate_pair(lockdownd_client_t client, lockdownd_pair_record_t pair_record)
Validates if the device is paired with the given HostID.
service_client_factory_start_service
service_error_t service_client_factory_start_service(idevice_t device, const char *service_name, void **client, const char *label, int32_t(*constructor_func)(idevice_t, lockdownd_service_descriptor_t, void **), int32_t *error_code)
Starts a new service on the specified device with given name and connects to it.
debugserver_client_send_command
debugserver_error_t debugserver_client_send_command(debugserver_client_t client, debugserver_command_t command, char **response, size_t *response_size)
Sends a command to the debugserver service.
lockdownd_pair_record::device_certificate
char * device_certificate
The device certificate.
Definition: lockdown.h:87
instproxy_uninstall
instproxy_error_t instproxy_uninstall(instproxy_client_t client, const char *appid, plist_t client_options, instproxy_status_cb_t status_cb, void *user_data)
Uninstall an application from the device.
syslog_relay_receive
syslog_relay_error_t syslog_relay_receive(syslog_relay_client_t client, char *data, uint32_t size, uint32_t *received)
Receives data from the service.
idevice_t
idevice_private * idevice_t
The device handle.
Definition: libimobiledevice.h:50
mobilebackup_client_free
mobilebackup_error_t mobilebackup_client_free(mobilebackup_client_t client)
Disconnects a mobilebackup client from the device and frees up the mobilebackup client data.
mobile_image_mounter_error_t
mobile_image_mounter_error_t
Error Codes.
Definition: mobile_image_mounter.h:37
companion_proxy_stop_forwarding_service_port
companion_proxy_error_t companion_proxy_stop_forwarding_service_port(companion_proxy_client_t client, uint16_t remote_port)
Stop forwarding a service port between companion device and idevice.
afc_make_directory
afc_error_t afc_make_directory(afc_client_t client, const char *path)
Creates a directory on the device.
instproxy_client_options_add
void instproxy_client_options_add(plist_t client_options,...)
Adds one or more new key:value pairs to the given client_options.
afc_get_device_info_key
afc_error_t afc_get_device_info_key(afc_client_t client, const char *key, char **value)
Get a specific key of the device info list for a client connection.
mobilesync_receive_changes
mobilesync_error_t mobilesync_receive_changes(mobilesync_client_t client, plist_t *entities, uint8_t *is_last_record, plist_t *actions)
Receives changed entitites of the currently set data class from the device.
lockdownd_goodbye
lockdownd_error_t lockdownd_goodbye(lockdownd_client_t client)
Sends the Goodbye request to lockdownd signaling the end of communication.
mobilesync_client_new
mobilesync_error_t mobilesync_client_new(idevice_t device, lockdownd_service_descriptor_t service, mobilesync_client_t *client)
Connects to the mobilesync service on the specified device.
mobilebackup2_receive_raw
mobilebackup2_error_t mobilebackup2_receive_raw(mobilebackup2_client_t client, char *data, uint32_t length, uint32_t *bytes)
Receive binary from the device.
lockdownd_client_set_label
void lockdownd_client_set_label(lockdownd_client_t client, const char *label)
Sets the label to send for requests to lockdownd.
instproxy_status_get_name
void instproxy_status_get_name(plist_t status, char **name)
Gets the name of a status.
instproxy_client_free
instproxy_error_t instproxy_client_free(instproxy_client_t client)
Disconnects an installation_proxy client from the device and frees up the installation_proxy client d...
afc_read_directory
afc_error_t afc_read_directory(afc_client_t client, const char *path, char ***directory_information)
Gets a directory listing of the directory requested.
libimobiledevice.h
Device/Connection handling and communication.
restored_query_value
restored_error_t restored_query_value(restored_client_t client, const char *key, plist_t *value)
Queries a value from the device specified by a key.
misagent_client_t
misagent_client_private * misagent_client_t
The client handle.
Definition: misagent.h:47
lockdownd_activate
lockdownd_error_t lockdownd_activate(lockdownd_client_t client, plist_t activation_record)
Activates the device.
mobileactivation_activate
mobileactivation_error_t mobileactivation_activate(mobileactivation_client_t client, plist_t activation_record)
Activates the device with the given activation record.
idevice_disconnect
idevice_error_t idevice_disconnect(idevice_connection_t connection)
Disconnect from the device and clean up the connection structure.
debugserver_command_free
debugserver_error_t debugserver_command_free(debugserver_command_t command)
Frees memory of command object.
sbservices_error_t
sbservices_error_t
Error Codes.
Definition: sbservices.h:37
mobilesync_send
mobilesync_error_t mobilesync_send(mobilesync_client_t client, plist_t plist)
Sends mobilesync data to the device.
afc_file_truncate
afc_error_t afc_file_truncate(afc_client_t client, uint64_t handle, uint64_t newsize)
Sets the size of a file on the device.
mobileactivation_create_activation_info
mobileactivation_error_t mobileactivation_create_activation_info(mobileactivation_client_t client, plist_t *info)
Retrieves the activation info required for device activation.
screenshotr_client_t
screenshotr_client_private * screenshotr_client_t
The client handle.
Definition: screenshotr.h:50
restored_error_t
restored_error_t
Error Codes.
Definition: restore.h:35
webinspector_error_t
webinspector_error_t
Error Codes.
Definition: webinspector.h:37
preboard_error_t
preboard_error_t
Error Codes.
Definition: preboard.h:36
debugserver_client_free
debugserver_error_t debugserver_client_free(debugserver_client_t client)
Disconnects a debugserver client from the device and frees up the debugserver client data.
webinspector_client_free
webinspector_error_t webinspector_client_free(webinspector_client_t client)
Disconnects a webinspector client from the device and frees up the webinspector client data.
afc_file_seek
afc_error_t afc_file_seek(afc_client_t client, uint64_t handle, int64_t offset, int whence)
Seeks to a given position of a pre-opened file on the device.
mobileactivation_error_t
mobileactivation_error_t
Error Codes.
Definition: mobileactivation.h:36
idevice_event_unsubscribe
idevice_error_t idevice_event_unsubscribe(void)
Release the event callback function that has been registered with idevice_event_subscribe().
AFC_LOCK_SH
shared lock
Definition: afc.h:87
idevice_connection_get_fd
idevice_error_t idevice_connection_get_fd(idevice_connection_t connection, int *fd)
Get the underlying file descriptor for a connection.
heartbeat_receive
heartbeat_error_t heartbeat_receive(heartbeat_client_t client, plist_t *plist)
Receives a plist from the service.
file_relay_request_sources_timeout
file_relay_error_t file_relay_request_sources_timeout(file_relay_client_t client, const char **sources, idevice_connection_t *connection, unsigned int timeout)
Request data for the given sources.
MOBILESYNC_SYNC_TYPE_FAST
Fast-sync requires that only the changes made since the last synchronization should be reported by th...
Definition: mobilesync.h:57
np_notify_cb_t
void(* np_notify_cb_t)(const char *notification, void *user_data)
Reports which notification was received.
Definition: notification_proxy.h:90
debugserver_client_set_argv
debugserver_error_t debugserver_client_set_argv(debugserver_client_t client, int argc, char *argv[], char **response)
Sets the argv which launches an app.
debugserver_command_new
debugserver_error_t debugserver_command_new(const char *name, int argc, char *argv[], debugserver_command_t *command)
Creates and initializes a new command object.
webinspector_client_start_service
webinspector_error_t webinspector_client_start_service(idevice_t device, webinspector_client_t *client, const char *label)
Starts a new webinspector service on the specified device and connects to it.
screenshotr_client_free
screenshotr_error_t screenshotr_client_free(screenshotr_client_t client)
Disconnects a screenshotr client from the device and frees up the screenshotr client data.
property_list_service_receive_plist
property_list_service_error_t property_list_service_receive_plist(property_list_service_client_t client, plist_t *plist)
Receives a plist using the given property list service client.
debugserver_client_receive
debugserver_error_t debugserver_client_receive(debugserver_client_t client, char *data, uint32_t size, uint32_t *received)
Receives raw data from the debugserver service.
lockdownd_enter_recovery
lockdownd_error_t lockdownd_enter_recovery(lockdownd_client_t client)
Tells the device to immediately enter recovery mode.
lockdownd_strerror
const char * lockdownd_strerror(lockdownd_error_t err)
Gets a readable error string for a given lockdown error code.
afc_truncate
afc_error_t afc_truncate(afc_client_t client, const char *path, uint64_t newsize)
Sets the size of a file on the device without prior opening it.
mobilesync_finish
mobilesync_error_t mobilesync_finish(mobilesync_client_t client)
Finish a synchronization session of a data class on the device.
lockdownd_service_descriptor
Definition: lockdown.h:96
property_list_service_receive_plist_with_timeout
property_list_service_error_t property_list_service_receive_plist_with_timeout(property_list_service_client_t client, plist_t *plist, unsigned int timeout)
Receives a plist using the given property list service client with specified timeout.
mobilebackup_error_t
mobilebackup_error_t
Error Codes.
Definition: mobilebackup.h:37
misagent_client_start_service
misagent_error_t misagent_client_start_service(idevice_t device, misagent_client_t *client, const char *label)
Starts a new misagent service on the specified device and connects to it.
debugserver_decode_string
void debugserver_decode_string(const char *encoded_buffer, size_t encoded_length, char **buffer)
Decodes a hex encoded string.
misagent_remove
misagent_error_t misagent_remove(misagent_client_t client, const char *profileID)
Removes a given provisioning profile.
AFC_FOPEN_RDONLY
r O_RDONLY
Definition: afc.h:71
restored_start_restore
restored_error_t restored_start_restore(restored_client_t client, plist_t options, uint64_t version)
Requests to start a restore and retrieve it's port on success.
mobileactivation_create_activation_session_info
mobileactivation_error_t mobileactivation_create_activation_session_info(mobileactivation_client_t client, plist_t *blob)
Retrieves a session blob required for 'drmHandshake' via albert.apple.com.
lockdownd_client_free
lockdownd_error_t lockdownd_client_free(lockdownd_client_t client)
Closes the lockdownd client session if one is running and frees up the lockdownd_client struct.
syslog_relay_receive_with_timeout
syslog_relay_error_t syslog_relay_receive_with_timeout(syslog_relay_client_t client, char *data, uint32_t size, uint32_t *received, unsigned int timeout)
Receives data using the given syslog_relay client with specified timeout.
idevice_get_device_list
idevice_error_t idevice_get_device_list(char ***devices, int *count)
Get a list of UDIDs of currently available devices (USBMUX devices only).
mobilebackup_send_backup_file_received
mobilebackup_error_t mobilebackup_send_backup_file_received(mobilebackup_client_t client)
Sends a confirmation to the device that a backup file has been received.
mobileactivation_client_new
mobileactivation_error_t mobileactivation_client_new(idevice_t device, lockdownd_service_descriptor_t service, mobileactivation_client_t *client)
Connects to the mobileactivation service on the specified device.
idevice_info
Definition: libimobiledevice.h:68
mobile_image_mounter_client_t
mobile_image_mounter_client_private * mobile_image_mounter_client_t
The client handle.
Definition: mobile_image_mounter.h:48
preboard_receive
preboard_error_t preboard_receive(preboard_client_t client, plist_t *plist)
Receives a plist from the service.
lockdownd_set_value
lockdownd_error_t lockdownd_set_value(lockdownd_client_t client, const char *domain, const char *key, plist_t value)
Sets a preferences value using a plist and optional by domain and/or key name.
mobile_image_mounter_free
mobile_image_mounter_error_t mobile_image_mounter_free(mobile_image_mounter_client_t client)
Disconnects a mobile_image_mounter client from the device and frees up the mobile_image_mounter clien...
mobilesync_sync_type_t
mobilesync_sync_type_t
The sync type of the current sync session.
Definition: mobilesync.h:56
file_relay_error_t
file_relay_error_t
Error Codes.
Definition: file_relay.h:38
service_client_new
service_error_t service_client_new(idevice_t device, lockdownd_service_descriptor_t service, service_client_t *client)
Creates a new service for the specified service descriptor.
diagnostics_relay_client_free
diagnostics_relay_error_t diagnostics_relay_client_free(diagnostics_relay_client_t client)
Disconnects a diagnostics_relay client from the device and frees up the diagnostics_relay client data...
lockdownd_service_descriptor_free
lockdownd_error_t lockdownd_service_descriptor_free(lockdownd_service_descriptor_t service)
Frees memory of a service descriptor as returned by lockdownd_start_service()
mobilebackup2_client_t
mobilebackup2_client_private * mobilebackup2_client_t
The client handle.
Definition: mobilebackup2.h:51
restored_client_set_label
void restored_client_set_label(restored_client_t client, const char *label)
Sets the label to send for requests to restored.
companion_proxy_stop_listening_for_devices
companion_proxy_error_t companion_proxy_stop_listening_for_devices(companion_proxy_client_t client)
Stops listening for paired devices.
mobile_image_mounter_start_service
mobile_image_mounter_error_t mobile_image_mounter_start_service(idevice_t device, mobile_image_mounter_client_t *client, const char *label)
Starts a new mobile_image_mounter service on the specified device and connects to it.
mobilesync_client_start_service
mobilesync_error_t mobilesync_client_start_service(idevice_t device, mobilesync_client_t *client, const char *label)
Starts a new mobilesync service on the specified device and connects to it.
instproxy_lookup
instproxy_error_t instproxy_lookup(instproxy_client_t client, const char **appids, plist_t client_options, plist_t *result)
Lookup information about specific applications from the device.
heartbeat_client_t
heartbeat_client_private * heartbeat_client_t
The client handle.
Definition: heartbeat.h:48
mobile_image_mounter_upload_image
mobile_image_mounter_error_t mobile_image_mounter_upload_image(mobile_image_mounter_client_t client, const char *image_type, size_t image_size, const char *signature, uint16_t signature_size, mobile_image_mounter_upload_cb_t upload_cb, void *userdata)
Uploads an image with an optional signature to the device.
lockdownd_pair_with_options
lockdownd_error_t lockdownd_pair_with_options(lockdownd_client_t client, lockdownd_pair_record_t pair_record, plist_t options, plist_t *response)
Pairs the device using the supplied pair record and passing the given options.
restored_client_free
restored_error_t restored_client_free(restored_client_t client)
Closes the restored client session if one is running and frees up the restored_client struct.
afc_lock_op_t
afc_lock_op_t
Lock operation flags.
Definition: afc.h:86
screenshotr_client_new
screenshotr_error_t screenshotr_client_new(idevice_t device, lockdownd_service_descriptor_t service, screenshotr_client_t *client)
Connects to the screenshotr service on the specified device.
afc_set_file_time
afc_error_t afc_set_file_time(afc_client_t client, const char *path, uint64_t mtime)
Sets the modification time of a file on the device.
mobilesync_client_t
mobilesync_client_private * mobilesync_client_t
The client handle.
Definition: mobilesync.h:63
lockdown.h
Manage device preferences, start services, pairing and activation.
mobilesync_receive
mobilesync_error_t mobilesync_receive(mobilesync_client_t client, plist_t *plist)
Polls the device for mobilesync data.
IDEVICE_LOOKUP_PREFER_NETWORK
prefer network connection if device is available via USBMUX and network
Definition: libimobiledevice.h:59
restored_goodbye
restored_error_t restored_goodbye(restored_client_t client)
Sends the Goodbye request to restored signaling the end of communication.
afc_file_read
afc_error_t afc_file_read(afc_client_t client, uint64_t handle, char *data, uint32_t length, uint32_t *bytes_read)
Attempts to the read the given number of bytes from the given file.
mobileactivation_deactivate
mobileactivation_error_t mobileactivation_deactivate(mobileactivation_client_t client)
Deactivates the device.
instproxy_client_options_new
plist_t instproxy_client_options_new(void)
Creates a new client_options plist.
afc_client_free
afc_error_t afc_client_free(afc_client_t client)
Frees up an AFC client.
lockdownd_get_device_name
lockdownd_error_t lockdownd_get_device_name(lockdownd_client_t client, char **device_name)
Retrieves the name of the device from lockdownd set by the user.
np_post_notification
np_error_t np_post_notification(np_client_t client, const char *notification)
Sends a notification to the device's notification_proxy.
afc.h
Access the filesystem on the device.
instproxy_archive
instproxy_error_t instproxy_archive(instproxy_client_t client, const char *appid, plist_t client_options, instproxy_status_cb_t status_cb, void *user_data)
Archive an application on the device.
companion_proxy_error_t
companion_proxy_error_t
Error Codes.
Definition: companion_proxy.h:36
mobilebackup_receive_restore_file_received
mobilebackup_error_t mobilebackup_receive_restore_file_received(mobilebackup_client_t client, plist_t *result)
Receive a confirmation from the device that it successfully received a restore file.
lockdownd_start_session
lockdownd_error_t lockdownd_start_session(lockdownd_client_t client, const char *host_id, char **session_id, int *ssl_enabled)
Opens a session with lockdownd and switches to SSL mode if device wants it.
mobilebackup_client_t
mobilebackup_client_private * mobilebackup_client_t
The client handle.
Definition: mobilebackup.h:50
service_receive_with_timeout
service_error_t service_receive_with_timeout(service_client_t client, char *data, uint32_t size, uint32_t *received, unsigned int timeout)
Receives data using the given service client with specified timeout.
idevice_event_type
idevice_event_type
The event type for device add or removal.
Definition: libimobiledevice.h:77
lockdownd_query_type
lockdownd_error_t lockdownd_query_type(lockdownd_client_t client, char **type)
Query the type of the service daemon.
lockdownd_send
lockdownd_error_t lockdownd_send(lockdownd_client_t client, plist_t plist)
Sends a plist to lockdownd.
service_disable_ssl
service_error_t service_disable_ssl(service_client_t client)
Disable SSL for the given service client.
idevice_get_udid
idevice_error_t idevice_get_udid(idevice_t device, char **udid)
Gets the unique id for the device.
afc_file_close
afc_error_t afc_file_close(afc_client_t client, uint64_t handle)
Closes a file on the device.
misagent_client_free
misagent_error_t misagent_client_free(misagent_client_t client)
Disconnects an misagent client from the device and frees up the misagent client data.
idevice_connection_type
idevice_connection_type
Type of connection a device is available on.
Definition: libimobiledevice.h:63
mobilesync_ready_to_send_changes_from_computer
mobilesync_error_t mobilesync_ready_to_send_changes_from_computer(mobilesync_client_t client)
Verifies if the device is ready to receive changes from the computer.
sbservices_client_start_service
sbservices_error_t sbservices_client_start_service(idevice_t device, sbservices_client_t *client, const char *label)
Starts a new sbservices service on the specified device and connects to it.
afc_file_mode_t
afc_file_mode_t
Flags for afc_file_open.
Definition: afc.h:70
mobilesync_get_changes_from_device
mobilesync_error_t mobilesync_get_changes_from_device(mobilesync_client_t client)
Requests to receive only changed records of the currently set data class from the device.
idevice_connection_enable_ssl
idevice_error_t idevice_connection_enable_ssl(idevice_connection_t connection)
Enables SSL for the given connection.
idevice_free
idevice_error_t idevice_free(idevice_t device)
Cleans up an idevice structure, then frees the structure itself.
mobilesync_actions_new
plist_t mobilesync_actions_new(void)
Create a new actions plist to use in mobilesync_send_changes().
webinspector_client_t
webinspector_client_private * webinspector_client_t
The client handle.
Definition: webinspector.h:49
syslog_relay_client_start_service
syslog_relay_error_t syslog_relay_client_start_service(idevice_t device, syslog_relay_client_t *client, const char *label)
Starts a new syslog_relay service on the specified device and connects to it.
debugserver_client_start_service
debugserver_error_t debugserver_client_start_service(idevice_t device, debugserver_client_t *client, const char *label)
Starts a new debugserver service on the specified device and connects to it.
afc_remove_path_and_contents
afc_error_t afc_remove_path_and_contents(afc_client_t client, const char *path)
Deletes a file or directory including possible contents.
diagnostics_relay_client_t
diagnostics_relay_client_private * diagnostics_relay_client_t
The client handle.
Definition: diagnostics_relay.h:57
sbservices_get_icon_state
sbservices_error_t sbservices_get_icon_state(sbservices_client_t client, plist_t *state, const char *format_version)
Gets the icon state of the connected device.
instproxy_client_options_set_return_attributes
void instproxy_client_options_set_return_attributes(plist_t client_options,...)
Adds attributes to the given client_options to filter browse results.
sbservices_client_new
sbservices_error_t sbservices_client_new(idevice_t device, lockdownd_service_descriptor_t service, sbservices_client_t *client)
Connects to the springboardservices service on the specified device.
idevice_error_t
idevice_error_t
Error Codes.
Definition: libimobiledevice.h:39
diagnostics_relay_client_new
diagnostics_relay_error_t diagnostics_relay_client_new(idevice_t device, lockdownd_service_descriptor_t service, diagnostics_relay_client_t *client)
Connects to the diagnostics_relay service on the specified device.
instproxy_status_get_error
instproxy_error_t instproxy_status_get_error(plist_t status, char **name, char **description, uint64_t *code)
Gets error name, code and description from a response if available.
sbservices_get_interface_orientation
sbservices_error_t sbservices_get_interface_orientation(sbservices_client_t client, sbservices_interface_orientation_t *interface_orientation)
Gets the interface orientation of the device.
afc_client_start_service
afc_error_t afc_client_start_service(idevice_t device, afc_client_t *client, const char *label)
Starts a new AFC service on the specified device and connects to it.
afc_dictionary_free
afc_error_t afc_dictionary_free(char **dictionary)
Frees up a char dictionary as returned by some AFC functions.
companion_proxy_client_t
companion_proxy_client_private * companion_proxy_client_t
The client handle.
Definition: companion_proxy.h:52
heartbeat_receive_with_timeout
heartbeat_error_t heartbeat_receive_with_timeout(heartbeat_client_t client, plist_t *plist, uint32_t timeout_ms)
Receives a plist using the given heartbeat client.
preboard_status_cb_t
void(* preboard_status_cb_t)(plist_t message, void *user_data)
Reports the status response of the given command.
Definition: preboard.h:52
property_list_service_enable_ssl
property_list_service_error_t property_list_service_enable_ssl(property_list_service_client_t client)
Enable SSL for the given property list service client.
AFC_LOCK_UN
unlock
Definition: afc.h:89
property_list_service_send_xml_plist
property_list_service_error_t property_list_service_send_xml_plist(property_list_service_client_t client, plist_t plist)
Sends an XML plist.
instproxy_client_options_free
void instproxy_client_options_free(plist_t client_options)
Frees client_options plist.
mobilesync_get_all_records_from_device
mobilesync_error_t mobilesync_get_all_records_from_device(mobilesync_client_t client)
Requests to receive all records of the currently set data class from the device.
file_relay_client_free
file_relay_error_t file_relay_client_free(file_relay_client_t client)
Disconnects a file_relay client from the device and frees up the file_relay client data.
instproxy_command_get_name
void instproxy_command_get_name(plist_t command, char **name)
Gets the name from a command dictionary.
mobilesync_start
mobilesync_error_t mobilesync_start(mobilesync_client_t client, const char *data_class, mobilesync_anchors_t anchors, uint64_t computer_data_class_version, mobilesync_sync_type_t *sync_type, uint64_t *device_data_class_version, char **error_description)
Requests starting synchronization of a data class with the device.
lockdownd_start_service_with_escrow_bag
lockdownd_error_t lockdownd_start_service_with_escrow_bag(lockdownd_client_t client, const char *identifier, lockdownd_service_descriptor_t *service)
Requests to start a service and retrieve it's port on success.
property_list_service_disable_ssl
property_list_service_error_t property_list_service_disable_ssl(property_list_service_client_t client)
Disable SSL for the given property list service client.
diagnostics_relay_goodbye
diagnostics_relay_error_t diagnostics_relay_goodbye(diagnostics_relay_client_t client)
Sends the Goodbye request signaling the end of communication.
diagnostics_relay_sleep
diagnostics_relay_error_t diagnostics_relay_sleep(diagnostics_relay_client_t client)
Puts the device into deep sleep mode and disconnects from host.
np_client_new
np_error_t np_client_new(idevice_t device, lockdownd_service_descriptor_t service, np_client_t *client)
Connects to the notification_proxy on the specified device.
mobilebackup_receive
mobilebackup_error_t mobilebackup_receive(mobilebackup_client_t client, plist_t *plist)
Polls the device for mobilebackup data.
instproxy_remove_archive
instproxy_error_t instproxy_remove_archive(instproxy_client_t client, const char *appid, plist_t client_options, instproxy_status_cb_t status_cb, void *user_data)
Removes a previously archived application from the device.
preboard_receive_with_timeout
preboard_error_t preboard_receive_with_timeout(preboard_client_t client, plist_t *plist, uint32_t timeout_ms)
Receives a plist from the service with the specified timeout.
lockdownd_pair
lockdownd_error_t lockdownd_pair(lockdownd_client_t client, lockdownd_pair_record_t pair_record)
Pairs the device using the supplied pair record.
mobileactivation_client_start_service
mobileactivation_error_t mobileactivation_client_start_service(idevice_t device, mobileactivation_client_t *client, const char *label)
Starts a new mobileactivation service on the specified device and connects to it.
afc_make_link
afc_error_t afc_make_link(afc_client_t client, afc_link_type_t linktype, const char *target, const char *linkname)
Creates a hard link or symbolic link on the device.
mobilebackup_request_backup
mobilebackup_error_t mobilebackup_request_backup(mobilebackup_client_t client, plist_t backup_manifest, const char *base_path, const char *proto_version)
Request a backup from the connected device.
idevice_device_list_free
idevice_error_t idevice_device_list_free(char **devices)
Free a list of device UDIDs.
instproxy_check_capabilities_match
instproxy_error_t instproxy_check_capabilities_match(instproxy_client_t client, const char **capabilities, plist_t client_options, plist_t *result)
Checks a device for certain capabilities.
mobile_image_mounter_lookup_image
mobile_image_mounter_error_t mobile_image_mounter_lookup_image(mobile_image_mounter_client_t client, const char *image_type, plist_t *result)
Tells if the image of ImageType is already mounted.
preboard_client_new
preboard_error_t preboard_client_new(idevice_t device, lockdownd_service_descriptor_t service, preboard_client_t *client)
Connects to the preboard service on the specified device.
lockdownd_deactivate
lockdownd_error_t lockdownd_deactivate(lockdownd_client_t client)
Deactivates the device, returning it to the locked “Activate with iTunes” screen.
service_send
service_error_t service_send(service_client_t client, const char *data, uint32_t size, uint32_t *sent)
Sends data using the given service client.
mobilesync_send_changes
mobilesync_error_t mobilesync_send_changes(mobilesync_client_t client, plist_t entities, uint8_t is_last_record, plist_t actions)
Sends changed entities of the currently set data class to the device.
preboard_send
preboard_error_t preboard_send(preboard_client_t client, plist_t plist)
Sends a plist to the service.
lockdownd_unpair
lockdownd_error_t lockdownd_unpair(lockdownd_client_t client, lockdownd_pair_record_t pair_record)
Unpairs the device with the given HostID and removes the pairing records from the device and host if ...
mobilesync_anchors
Definition: mobilesync.h:65
mobilebackup2_receive_message
mobilebackup2_error_t mobilebackup2_receive_message(mobilebackup2_client_t client, plist_t *msg_plist, char **dlmessage)
Receives a DL* message plist from the device.
instproxy_status_cb_t
void(* instproxy_status_cb_t)(plist_t command, plist_t status, void *user_data)
Reports the status response of the given command.
Definition: installation_proxy.h:114
mobileactivation_create_activation_info_with_session
mobileactivation_error_t mobileactivation_create_activation_info_with_session(mobileactivation_client_t client, plist_t handshake_response, plist_t *info)
Retrieves the activation info required for device activation in 'session' mode.
property_list_service_client_t
property_list_service_private * property_list_service_client_t
The client handle.
Definition: property_list_service.h:46
webinspector_receive
webinspector_error_t webinspector_receive(webinspector_client_t client, plist_t *plist)
Receives a plist from the service.
syslog_relay_client_t
syslog_relay_client_private * syslog_relay_client_t
The client handle.
Definition: syslog_relay.h:48
IDEVICE_LOOKUP_USBMUX
include USBMUX devices during lookup
Definition: libimobiledevice.h:57
misagent_error_t
misagent_error_t
Error Codes.
Definition: misagent.h:37
idevice_connect
idevice_error_t idevice_connect(idevice_t device, uint16_t port, idevice_connection_t *connection)
Set up a connection to the given device.
sbservices_get_icon_pngdata
sbservices_error_t sbservices_get_icon_pngdata(sbservices_client_t client, const char *bundleId, char **pngdata, uint64_t *pngsize)
Get the icon of the specified app as PNG data.
house_arrest_send_request
house_arrest_error_t house_arrest_send_request(house_arrest_client_t client, plist_t dict)
Sends a generic request to the connected house_arrest service.
mobilesync_actions_add
void mobilesync_actions_add(plist_t actions,...)
Add one or more new key:value pairs to the given actions plist.
MOBILESYNC_SYNC_TYPE_RESET
Reset-sync signals that the computer should send all data again.
Definition: mobilesync.h:59
AFC_FOPEN_RDAPPEND
a+ O_RDWR | O_APPEND | O_CREAT
Definition: afc.h:76
instproxy_status_get_current_list
void instproxy_status_get_current_list(plist_t status, uint64_t *total, uint64_t *current_index, uint64_t *current_amount, plist_t *list)
Gets total and current item information from a browse response if available.
mobilebackup2_send_request
mobilebackup2_error_t mobilebackup2_send_request(mobilebackup2_client_t client, const char *request, const char *target_identifier, const char *source_identifier, plist_t options)
Send a request to the connected mobilebackup2 service.
afc_get_file_info
afc_error_t afc_get_file_info(afc_client_t client, const char *path, char ***file_information)
Gets information about a specific file.
syslog_relay_stop_capture
syslog_relay_error_t syslog_relay_stop_capture(syslog_relay_client_t client)
Stops capturing the syslog of the device.
file_relay_client_new
file_relay_error_t file_relay_client_new(idevice_t device, lockdownd_service_descriptor_t service, file_relay_client_t *client)
Connects to the file_relay service on the specified device.
mobilesync_actions_free
void mobilesync_actions_free(plist_t actions)
Free actions plist.
service_client_free
service_error_t service_client_free(service_client_t client)
Frees a service instance.
property_list_service_client_new
property_list_service_error_t property_list_service_client_new(idevice_t device, lockdownd_service_descriptor_t service, property_list_service_client_t *client)
Creates a new property list service for the specified port.
lockdownd_receive
lockdownd_error_t lockdownd_receive(lockdownd_client_t client, plist_t *plist)
Receives a plist from lockdownd.
instproxy_lookup_archives
instproxy_error_t instproxy_lookup_archives(instproxy_client_t client, plist_t client_options, plist_t *result)
List archived applications.
file_relay_client_start_service
file_relay_error_t file_relay_client_start_service(idevice_t device, file_relay_client_t *client, const char *label)
Starts a new file_relay service on the specified device and connects to it.
idevice_connection_disable_bypass_ssl
idevice_error_t idevice_connection_disable_bypass_ssl(idevice_connection_t connection, uint8_t sslBypass)
Disable bypass SSL for the given connection without sending out terminate messages.
preboard_client_start_service
preboard_error_t preboard_client_start_service(idevice_t device, preboard_client_t *client, const char *label)
Starts a new preboard service on the specified device and connects to it.
preboard_client_free
preboard_error_t preboard_client_free(preboard_client_t client)
Disconnects a preboard client from the device and frees up the preboard client data.
mobilebackup2_send_raw
mobilebackup2_error_t mobilebackup2_send_raw(mobilebackup2_client_t client, const char *data, uint32_t length, uint32_t *bytes)
Send binary data to the device.
diagnostics_relay_request_diagnostics
diagnostics_relay_error_t diagnostics_relay_request_diagnostics(diagnostics_relay_client_t client, const char *type, plist_t *diagnostics)
Shutdown of the device and optionally show a user notification.
mobilebackup_client_new
mobilebackup_error_t mobilebackup_client_new(idevice_t device, lockdownd_service_descriptor_t service, mobilebackup_client_t *client)
Connects to the mobilebackup service on the specified device.
companion_proxy_get_device_registry
companion_proxy_error_t companion_proxy_get_device_registry(companion_proxy_client_t client, plist_t *paired_devices)
Retrieves a list of paired devices.
idevice_event_t
Provides information about the occurred event.
Definition: libimobiledevice.h:85
house_arrest_send_command
house_arrest_error_t house_arrest_send_command(house_arrest_client_t client, const char *command, const char *appid)
Send a command to the connected house_arrest service.
lockdownd_get_device_udid
lockdownd_error_t lockdownd_get_device_udid(lockdownd_client_t client, char **udid)
Returns the unique id of the device from lockdownd.
afc_file_lock
afc_error_t afc_file_lock(afc_client_t client, uint64_t handle, afc_lock_op_t operation)
Locks or unlocks a file on the device.
restored_client_t
restored_client_private * restored_client_t
The client handle.
Definition: restore.h:46
idevice_options
idevice_options
Options for idevice_new_with_options()
Definition: libimobiledevice.h:56
AFC_FOPEN_RW
r+ O_RDWR | O_CREAT
Definition: afc.h:72
preboard_client_t
preboard_client_private * preboard_client_t
The client handle.
Definition: preboard.h:49
syslog_relay_client_free
syslog_relay_error_t syslog_relay_client_free(syslog_relay_client_t client)
Disconnects a syslog_relay client from the device and frees up the syslog_relay client data.
mobilebackup2_client_free
mobilebackup2_error_t mobilebackup2_client_free(mobilebackup2_client_t client)
Disconnects a mobilebackup2 client from the device and frees up the mobilebackup2 client data.
restored_receive
restored_error_t restored_receive(restored_client_t client, plist_t *plist)
Receives a plist from restored.
afc_get_device_info
afc_error_t afc_get_device_info(afc_client_t client, char ***device_information)
Get device information for a connected client.
misagent_install
misagent_error_t misagent_install(misagent_client_t client, plist_t profile)
Installs the given provisioning profile.
mobile_image_mounter_new
mobile_image_mounter_error_t mobile_image_mounter_new(idevice_t device, lockdownd_service_descriptor_t service, mobile_image_mounter_client_t *client)
Connects to the mobile_image_mounter service on the specified device.
instproxy_upgrade
instproxy_error_t instproxy_upgrade(instproxy_client_t client, const char *pkg_path, plist_t client_options, instproxy_status_cb_t status_cb, void *user_data)
Upgrade an application on the device.
afc_client_new
afc_error_t afc_client_new(idevice_t device, lockdownd_service_descriptor_t service, afc_client_t *client)
Makes a connection to the AFC service on the device.
instproxy_client_start_service
instproxy_error_t instproxy_client_start_service(idevice_t device, instproxy_client_t *client, const char *label)
Starts a new installation_proxy service on the specified device and connects to it.
instproxy_browse
instproxy_error_t instproxy_browse(instproxy_client_t client, plist_t client_options, plist_t *result)
List installed applications.
syslog_relay_start_capture_raw
syslog_relay_error_t syslog_relay_start_capture_raw(syslog_relay_client_t client, syslog_relay_receive_cb_t callback, void *user_data)
Starts capturing the raw syslog of the device using a callback.
lockdownd_remove_value
lockdownd_error_t lockdownd_remove_value(lockdownd_client_t client, const char *domain, const char *key)
Removes a preference node by domain and/or key name.
file_relay_request_sources
file_relay_error_t file_relay_request_sources(file_relay_client_t client, const char **sources, idevice_connection_t *connection)
Request data for the given sources.
lockdownd_start_service
lockdownd_error_t lockdownd_start_service(lockdownd_client_t client, const char *identifier, lockdownd_service_descriptor_t *service)
Requests to start a service and retrieve it's port on success.
service_client_t
service_client_private * service_client_t
The client handle.
Definition: service.h:46
house_arrest_client_new
house_arrest_error_t house_arrest_client_new(idevice_t device, lockdownd_service_descriptor_t service, house_arrest_client_t *client)
Connects to the house_arrest service on the specified device.
companion_proxy_send
companion_proxy_error_t companion_proxy_send(companion_proxy_client_t client, plist_t plist)
Sends a plist to the service.
diagnostics_relay_error_t
diagnostics_relay_error_t
Error Codes.
Definition: diagnostics_relay.h:36
heartbeat_send
heartbeat_error_t heartbeat_send(heartbeat_client_t client, plist_t plist)
Sends a plist to the service.
service_receive
service_error_t service_receive(service_client_t client, char *data, uint32_t size, uint32_t *received)
Receives data using the given service client.
afc_client_t
afc_client_private * afc_client_t
The client handle.
Definition: afc.h:93
syslog_relay_client_new
syslog_relay_error_t syslog_relay_client_new(idevice_t device, lockdownd_service_descriptor_t service, syslog_relay_client_t *client)
Connects to the syslog_relay service on the specified device.
debugserver_client_set_ack_mode
debugserver_error_t debugserver_client_set_ack_mode(debugserver_client_t client, int enabled)
Controls status of ACK mode when sending commands or receiving responses.
mobileactivation_client_t
mobileactivation_client_private * mobileactivation_client_t
The client handle.
Definition: mobileactivation.h:47
restored_reboot
restored_error_t restored_reboot(restored_client_t client)
Requests device to reboot.
idevice_connection_disable_ssl
idevice_error_t idevice_connection_disable_ssl(idevice_connection_t connection)
Disable SSL for the given connection.
afc_file_tell
afc_error_t afc_file_tell(afc_client_t client, uint64_t handle, uint64_t *position)
Returns current position in a pre-opened file on the device.
heartbeat_client_free
heartbeat_error_t heartbeat_client_free(heartbeat_client_t client)
Disconnects a heartbeat client from the device and frees up the heartbeat client data.
AFC_FOPEN_WR
w+ O_RDWR | O_CREAT | O_TRUNC
Definition: afc.h:74
IDEVICE_LOOKUP_NETWORK
include network devices during lookup
Definition: libimobiledevice.h:58
afc_file_open
afc_error_t afc_file_open(afc_client_t client, const char *filename, afc_file_mode_t file_mode, uint64_t *handle)
Opens a file on the device.
lockdownd_pair_record::host_id
char * host_id
A unique HostID for the host computer.
Definition: lockdown.h:90
house_arrest_client_start_service
house_arrest_error_t house_arrest_client_start_service(idevice_t device, house_arrest_client_t *client, const char *label)
Starts a new house_arrest service on the specified device and connects to it.
syslog_relay_error_t
syslog_relay_error_t
Error Codes.
Definition: syslog_relay.h:37
lockdownd_pair_record::host_certificate
char * host_certificate
The host certificate.
Definition: lockdown.h:88
np_set_notify_callback
np_error_t np_set_notify_callback(np_client_t client, np_notify_cb_t notify_cb, void *userdata)
This function allows an application to define a callback function that will be called when a notifica...
misagent_client_new
misagent_error_t misagent_client_new(idevice_t device, lockdownd_service_descriptor_t service, misagent_client_t *client)
Connects to the misagent service on the specified device.
companion_proxy_client_start_service
companion_proxy_error_t companion_proxy_client_start_service(idevice_t device, companion_proxy_client_t *client, const char *label)
Starts a new companion_proxy service on the specified device and connects to it.
mobilesync_client_free
mobilesync_error_t mobilesync_client_free(mobilesync_client_t client)
Disconnects a mobilesync client from the device and frees up the mobilesync client data.
mobilesync_anchors_t
mobilesync_anchors * mobilesync_anchors_t
Anchors used by the device and computer.
Definition: mobilesync.h:69
heartbeat_error_t
heartbeat_error_t
Error Codes.
Definition: heartbeat.h:36
idevice_event_t::udid
const char * udid
The device unique id.
Definition: libimobiledevice.h:87
instproxy_status_get_percent_complete
void instproxy_status_get_percent_complete(plist_t status, int *percent)
Gets progress in percentage from a status if available.
instproxy_browse_with_callback
instproxy_error_t instproxy_browse_with_callback(instproxy_client_t client, plist_t client_options, instproxy_status_cb_t status_cb, void *user_data)
List pages of installed applications in a callback.
lockdownd_stop_session
lockdownd_error_t lockdownd_stop_session(lockdownd_client_t client, const char *session_id)
Closes the lockdownd session by sending the StopSession request.
debugserver_client_receive_with_timeout
debugserver_error_t debugserver_client_receive_with_timeout(debugserver_client_t client, char *data, uint32_t size, uint32_t *received, unsigned int timeout)
Receives raw data using the given debugserver client with specified timeout.
debugserver_client_send
debugserver_error_t debugserver_client_send(debugserver_client_t client, const char *data, uint32_t size, uint32_t *sent)
Sends raw data using the given debugserver service client.
mobilesync_cancel
mobilesync_error_t mobilesync_cancel(mobilesync_client_t client, const char *reason)
Cancels a running synchronization session with a device at any time.
misagent_get_status_code
int misagent_get_status_code(misagent_client_t client)
Retrieves the status code from the last operation.
mobilebackup_receive_restore_application_received
mobilebackup_error_t mobilebackup_receive_restore_application_received(mobilebackup_client_t client, plist_t *result)
Receive a confirmation from the device that it successfully received application data file.
instproxy_client_new
instproxy_error_t instproxy_client_new(idevice_t device, lockdownd_service_descriptor_t service, instproxy_client_t *client)
Connects to the installation_proxy service on the specified device.
preboard_commit_stashbag
preboard_error_t preboard_commit_stashbag(preboard_client_t client, plist_t manifest, preboard_status_cb_t status_cb, void *user_data)
Instructs the preboard service to commit a previously created stashbag.
restored_query_type
restored_error_t restored_query_type(restored_client_t client, char **type, uint64_t *version)
Query the type of the service daemon.
lockdownd_client_new
lockdownd_error_t lockdownd_client_new(idevice_t device, lockdownd_client_t *client, const char *label)
Creates a new lockdownd client for the device.
diagnostics_relay_shutdown
diagnostics_relay_error_t diagnostics_relay_shutdown(diagnostics_relay_client_t client, diagnostics_relay_action_t flags)
Shutdown of the device and optionally show a user notification.
idevice_connection_receive_timeout
idevice_error_t idevice_connection_receive_timeout(idevice_connection_t connection, char *data, uint32_t len, uint32_t *recv_bytes, unsigned int timeout)
Receive data from a device via the given connection.
lockdownd_client_new_with_handshake
lockdownd_error_t lockdownd_client_new_with_handshake(idevice_t device, lockdownd_client_t *client, const char *label)
Creates a new lockdownd client for the device and starts initial handshake.
np_client_t
np_client_private * np_client_t
The client handle.
Definition: notification_proxy.h:87
mobile_image_mounter_hangup
mobile_image_mounter_error_t mobile_image_mounter_hangup(mobile_image_mounter_client_t client)
Hangs up the connection to the mobile_image_mounter service.
mobilebackup2_send_status_response
mobilebackup2_error_t mobilebackup2_send_status_response(mobilebackup2_client_t client, int status_code, const char *status1, plist_t status2)
Sends a DLMessageStatusResponse to the device.
mobilesync_error_t
mobilesync_error_t
Error Codes.
Definition: mobilesync.h:40
lockdownd_pair_record
A pair record holding device, host and root certificates along the host_id.
Definition: lockdown.h:86
house_arrest_client_free
house_arrest_error_t house_arrest_client_free(house_arrest_client_t client)
Disconnects an house_arrest client from the device and frees up the house_arrest client data.
lockdownd_pair_record::root_certificate
char * root_certificate
The root certificate.
Definition: lockdown.h:89
idevice_set_debug_level
void idevice_set_debug_level(int level)
Set the level of debugging.
companion_proxy_client_free
companion_proxy_error_t companion_proxy_client_free(companion_proxy_client_t client)
Disconnects a companion_proxy client from the device and frees up the companion_proxy client data.
mobilesync_clear_all_records_on_device
mobilesync_error_t mobilesync_clear_all_records_on_device(mobilesync_client_t client)
Requests the device to delete all records of the current data class.
restored_get_value
restored_error_t restored_get_value(restored_client_t client, const char *key, plist_t *value)
Retrieves a value from information plist specified by a key.
companion_proxy_client_new
companion_proxy_error_t companion_proxy_client_new(idevice_t device, lockdownd_service_descriptor_t service, companion_proxy_client_t *client)
Connects to the companion_proxy service on the specified device.
webinspector_client_new
webinspector_error_t webinspector_client_new(idevice_t device, lockdownd_service_descriptor_t service, webinspector_client_t *client)
Connects to the webinspector service on the specified device.
companion_proxy_receive
companion_proxy_error_t companion_proxy_receive(companion_proxy_client_t client, plist_t *plist)
Receives a plist from the service.
syslog_relay_receive_cb_t
void(* syslog_relay_receive_cb_t)(char c, void *user_data)
Receives each character received from the device.
Definition: syslog_relay.h:51
instproxy_client_t
instproxy_client_private * instproxy_client_t
The client handle.
Definition: installation_proxy.h:111
np_client_free
np_error_t np_client_free(np_client_t client)
Disconnects a notification_proxy client from the device and frees up the notification_proxy client da...
diagnostics_relay_restart
diagnostics_relay_error_t diagnostics_relay_restart(diagnostics_relay_client_t client, diagnostics_relay_action_t flags)
Restart the device and optionally show a user notification.
heartbeat_client_new
heartbeat_error_t heartbeat_client_new(idevice_t device, lockdownd_service_descriptor_t service, heartbeat_client_t *client)
Connects to the heartbeat service on the specified device.
mobilebackup2_version_exchange
mobilebackup2_error_t mobilebackup2_version_exchange(mobilebackup2_client_t client, double local_versions[], char count, double *remote_version)
Performs the mobilebackup2 protocol version exchange.
mobilebackup2_send_message
mobilebackup2_error_t mobilebackup2_send_message(mobilebackup2_client_t client, const char *message, plist_t options)
Sends a backup message plist.
MOBILESYNC_SYNC_TYPE_SLOW
Slow-sync requires that all data from the computer needs to be synchronized/sent.
Definition: mobilesync.h:58
lockdownd_get_sync_data_classes
lockdownd_error_t lockdownd_get_sync_data_classes(lockdownd_client_t client, char ***classes, int *count)
Calculates and returns the data classes the device supports from lockdownd.
heartbeat_client_start_service
heartbeat_error_t heartbeat_client_start_service(idevice_t device, heartbeat_client_t *client, const char *label)
Starts a new heartbeat service on the specified device and connects to it.
mobilesync_anchors_free
void mobilesync_anchors_free(mobilesync_anchors_t anchors)
Free memory used by anchors.
instproxy_client_get_path_for_bundle_identifier
instproxy_error_t instproxy_client_get_path_for_bundle_identifier(instproxy_client_t client, const char *bundle_id, char **path)
Queries the device for the path of an application.
house_arrest_get_result
house_arrest_error_t house_arrest_get_result(house_arrest_client_t client, plist_t *dict)
Retrieves the result of a previously sent house_arrest_request_* request.
idevice_new_with_options
idevice_error_t idevice_new_with_options(idevice_t *device, const char *udid, enum idevice_options options)
Creates an idevice_t structure for the device specified by UDID, if the device is available,...
np_observe_notifications
np_error_t np_observe_notifications(np_client_t client, const char **notification_spec)
Tells the device to send a notification on specified events.
idevice_get_handle
idevice_error_t idevice_get_handle(idevice_t device, uint32_t *handle)
Gets the handle or (usbmux device id) of the device.
AFC_LOCK_EX
exclusive lock
Definition: afc.h:88
debugserver_encode_string
void debugserver_encode_string(const char *buffer, char **encoded_buffer, uint32_t *encoded_length)
Encodes a string into hex notation.
sbservices_client_free
sbservices_error_t sbservices_client_free(sbservices_client_t client)
Disconnects an sbservices client from the device and frees up the sbservices client data.
mobileactivation_activate_with_session
mobileactivation_error_t mobileactivation_activate_with_session(mobileactivation_client_t client, plist_t activation_record, plist_t headers)
Activates the device with the given activation record in 'session' mode.
property_list_service_client_free
property_list_service_error_t property_list_service_client_free(property_list_service_client_t client)
Frees a PropertyList service.
mobile_image_mounter_mount_image
mobile_image_mounter_error_t mobile_image_mounter_mount_image(mobile_image_mounter_client_t client, const char *image_path, const char *signature, uint16_t signature_size, const char *image_type, plist_t *result)
Mounts an image on the device.
sbservices_get_home_screen_wallpaper_pngdata
sbservices_error_t sbservices_get_home_screen_wallpaper_pngdata(sbservices_client_t client, char **pngdata, uint64_t *pngsize)
Get the home screen wallpaper as PNG data.
np_client_start_service
np_error_t np_client_start_service(idevice_t device, np_client_t *client, const char *label)
Starts a new notification proxy service on the specified device and connects to it.
AFC_FOPEN_APPEND
a O_WRONLY | O_APPEND | O_CREAT
Definition: afc.h:75
afc_remove_path
afc_error_t afc_remove_path(afc_client_t client, const char *path)
Deletes a file or directory.
idevice_connection_t
idevice_connection_private * idevice_connection_t
The connection handle.
Definition: libimobiledevice.h:53
screenshotr_client_start_service
screenshotr_error_t screenshotr_client_start_service(idevice_t device, screenshotr_client_t *client, const char *label)
Starts a new screenshotr service on the specified device and connects to it.
file_relay_client_t
file_relay_client_private * file_relay_client_t
The client handle.
Definition: file_relay.h:50